<?php
// index.php
// Matthew Whiting Nov 2007
// From the original by Albert Teoh 
// 
// The opening page for the ATNF Pulsar Data Archive
// system. Used to search for observation archive
// files.

// BEGIN Javascript for expansion blocks 
// Thanks to: 
// http://assn9.blogspot.com/ 
// Douglas Bowman
// URL:      www.stopdesign.com
// Used in: http://www.bloggerforum.com/modules/newbb/viewtopic.php?topic_id=8725&forum=6
// Date:     26 Feb 2004



session_start();



require_once 'constants.php';
require_once 'security.php';
require_once 'PulsarArchiveDB.php';
require_once 'date.php';
require_once 'logger.php';

include 'header.html';



function OutputHeader()
{
  echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html>';
  echo '<head>';
  echo '<link rel="stylesheet" type="text/css" href="styles/opal.css" />';
  echo '<link rel="stylesheet" type="text/css" href="styles/style.css" />';
  echo '<link rel="stylesheet" type="text/css" href="styles/query.css" />';
  echo '<link rel="stylesheet" type="text/css" href="styles/results.css" />';
  echo '<link rel="stylesheet" type="text/css" href="styles/atnf.css" />';
  echo '<meta http-equiv="Content-Type" content="text/html; charset=iso-8759-1" />';
  echo '<meta name="DC.Creator" lang="en" content="personalName=Teoh,Albert" />';
  echo '<meta name="ATNF.Maintainer" content="contactName=Webmaster,the" />';
  echo '<meta name="DC.Title.alt" lang="en" content="" />';
  echo '<meta name="DC.Subject" lang="en" content="pulsar" />';
  echo '<meta name="DC.Description" lang="en" content="Searches the data archives at the ATNF" />';
  echo '<meta name="DC.Date.created" scheme="ISO8601" content="2002-12-12" />';
  echo '<meta name="ATNF.Site" content="Marsfield" />';
  echo '<meta name="ATNF.AccessPermission" content="Public" />';
  echo '<meta name="ATNF.MetaVersion" content="1.0" />';

  echo '<script type="text/javascript" src="scripts/atnf-oo-utils.js"></script>';
  echo '<script type="text/javascript" src="scripts/atnf-string-utils.js"></script>';
  echo '<script type="text/javascript" src="scripts/atnf-dom-utils.js"></script>';
  echo '<script type="text/javascript" src="scripts/atnf-validation.js"></script>';
  echo '<script type="text/javascript" src="scripts/atoa-query.js"></script>';
  echo '<script type="text/javascript" src="scripts/tooltips.js"></script>';
  echo '<script type="text/javascript" src="scripts/pulsarvo.js"></script>';

//    <script type="text/javascript" src="scripts/atnf-dom-utils.js"></script>
//    <script type="text/javascript" src="scripts/atoa-query.js"></script>
//    <script type="text/javascript" src="scripts/process.js"></script>

  echo '</head>';
  echo '<title>ATNF Pulsar Data Archive Home</title>';
}



function OutputLoginForm()
{
  global $_SERVER;
  
  echo '<body class="front_page">';

  echo '<div class="bodycontents">';

  echo '<h1>The ATNF Pulsar Data Archive</h1>';

  echo '<p>The ATNF Pulsar Data Archive provides access to pulsar observations';
  echo 'made with the Parkes radio Telescope. Data older than <b>';
  echo '<?php echo PROPRIETRY_PERIOD_MONTH ?> months</b> is';
  echo 'publicly available, and can be accessed by simply providing your email';
  echo 'address. More recent data is proprietry, and can only be accessed by';
  echo 'those who were involved in the proposal. We plan to do this via the';
  echo '<a href="http://opal.atnf.csiro.au">OPAL system</a>, but this is';
  echo 'currently not enabled. In the interim, those who have previously';
  echo 'obtained a login for the Data Archive can use that option below';
  echo '(making sure to check the "Data Archive login" button!). </p>';

  echo '<p>A <a href="pulsar_archive_guide.html">Users Guide</a> to the archive is available.</p> ';

  echo '<form action="' . $_SERVER['PHP_SELF'] . '" method="POST">';
  echo '<table width="700" style="border: 0px;">';

  echo '<tr>';
  echo '<td><input type="radio" name="authenticateType" checked value="anon">Non-proprietry access<br> ';
  echo '<table class="login" width="500" style="border: 0px;">'; 
  echo '<tr>';
  echo '<td class="form_field">Email: </td>';
  echo '<td><input type="text" name="email"></td>';
  echo '</tr>';
  echo '</table>';
  echo '<br>';
  echo '</td>';
  echo '</tr>';

  echo '<tr>';

  echo '<td><input type="radio" name="authenticateType" value="opal">Data Archive login<br>';
  echo '<table class="login" width="500" style="border: 0px;">';
  echo '<tr><td class="form_field">Username: </td><td><input type="text" name="opalEmail"></td></tr>';
  echo '<tr><td class="form_field">Password: </td><td><input type="password" name="opalPassword"></td></tr>';
  echo '</table>';
  echo '<br>';
  echo '</td>';
  echo '</tr>';

  echo '<tr>';
  echo '<td><input type="submit" value="Login" name="action"><input type="reset" value="Reset"></td>';
  echo '</tr>';
  echo '</table>';

  echo '</form>';
}



function OutputQueryFormHeader( $min_date_text, $max_date_text )
{
  global $PHP_SELF;
  
  echo '<body class="atoa">';
  echo '<div class="bodycontents">';

  echo '<h1>ATNF Pulsar Data Archive</h1>';

  echo '<p>This archive provides access to pulsar observations taken at the Parkes radio telescope between the dates of ';
  echo '<b>' . $min_date_text . '</b> and <b>' . $max_date_text . '</b>.</p>';

  echo '<p>See the Users Guide link for more details. </p>';

  echo '<table width="700" style="border: 0px;">';
  echo '<tr align="center">';
  echo '<td>';
  echo '<a class="top_menu" href="' . $PHP_SELF . '?command=logout">Logout</a>';
  echo '<!--a href="login?_action=logout">Logout</a-->';

  echo '</td>';
  echo '<td>';
  echo '<a href="#" onClick="toggleInstructions();return false;">Instructions</a>';
  echo '</td>';
  echo '<td size="30">';
  echo '&nbsp;';
  echo '</td>';
  echo '<td>';
  echo '<a href="pulsar_archive_guide.html">Users Guide</a>';
  echo '</td>';
  echo '</tr>';

  echo '</table>';

  echo '<div id="divInstructions" style="display:none" >';
  echo '<dl class="top">';
  echo '<h2>Instructions</h2>';
  echo '<i>To hide, click "Instructions" again. </i>';
  echo '<dt> Display Parameters </dt>';
  echo '<dd> Check the fields you want shown in the results table. Suggested columns are checked by default</dd>';
  echo '<dd> The results can be ordered by one of the parameters in the "Order By" drop-down list</dd>';
  echo '<dt> Coordinates </dt>';
  echo '<dd> The sky position can be specified by a Pulsar name or a RA/Dec position. ';
  echo 'The pulsar name takes precedence. The search radius must be given. </dd>'; 
  echo '<dt> Filter Options </dt>';
  echo '<dd> Results can be limited to observations just from a particular project - use the Project ID box</dd>';
  echo '<dd> The date range can be specified - the defaults are the range of dates in the archive.</dd>';
  echo '<dd> Either timing data (particular pulsar) or survey data can be specified. Or both! </dd> ';
  echo '<dd> The type of instrument can be specified. Default is any type.</dd>';
  echo '<dd> More than one frequency band can be specified.';
  echo '<dt> Display Other </dt>';
  echo '<dd> Calibraton observations taken within a given time period of the queried observations can also be shown and downloaded. Check the box to do so, and specify the time interval. </dd> ';
  echo '</dl>';
  echo '</div>';
}



OutputHeader();




// The fields to display in the results
if( isset( $_SESSION['fields'] ) )
    $selected_fields = $_SESSION['fields'];
else
  $selected_fields = Array( "filename", "src_name", "project_id", "raj", "decj", 
			    "data_type", "obsfreq", "bw", "scanlen", "date", "ut", "nsub", "nchan" );

// set some form defaults

isset($_SESSION['pulsar_name']) ? $pulsar_name = $_SESSION['pulsar_name'] : $pulsar_name = '';
isset($_SESSION['project_id']) ? $project_id = $_SESSION['project_id'] : $project_id = '';
isset($_SESSION['obs_mode']) ? $obs_mode = $_SESSION['obs_mode'] : $obs_mode = '';
isset($_SESSION['data_type']) ? $data_type = $_SESSION['data_type'] : $data_type = '';
isset($_SESSION['orderBy']) ? $orderBy = $_SESSION['orderBy'] : $orderBy = '';
isset($_SESSION['orderDir']) ?$orderDir = $_SESSION['orderDir'] : $orderDir = 'asc';
isset($_SESSION['survey']) ? $survey = $_SESSION['survey'] : $survey = '';
isset($_SESSION['rahour']) ? $rahour = $_SESSION['rahour'] : $rahour = '';
isset($_SESSION['ramin']) ? $ramin = $_SESSION['ramin'] : $ramin = '';
isset($_SESSION['rasec']) ? $rasec = $_SESSION['rasec'] : $rasec = '';
isset($_SESSION['decdeg']) ? $decdeg = $_SESSION['decdeg'] : $decdeg = '';
isset($_SESSION['decmin']) ? $decmin = $_SESSION['decmin'] : $decmin = '';
isset($_SESSION['decsec']) ? $decsec = $_SESSION['decsec'] : $decsec = '';
isset($_SESSION['radius']) ? $radius = $_SESSION['radius'] : $radius = 60;
isset($_SESSION['bandname']) ? $bandname = $_SESSION['bandname'] : $bandname = Array();
isset($_SESSION['from_day']) ? $from_day = $_SESSION['from_day'] : $from_day = '';
isset($_SESSION['from_month']) ?$from_month = $_SESSION['from_month'] : $from_month = '';
isset($_SESSION['from_year']) ? $from_year = $_SESSION['from_year'] : $from_year = '';
isset($_SESSION['to_day']) ? $to_day = $_SESSION['to_day'] : $to_day = '';
isset($_SESSION['to_month']) ? $to_month = $_SESSION['to_month'] : $to_month = '';
isset($_SESSION['to_year']) ? $to_year = $_SESSION['to_year'] : $to_year = '';
isset($_SESSION['cals_within_mins']) ? $cals_within_mins = $_SESSION['cals_within_mins'] : $cals_within_mins = 30;
isset($_SESSION['cals']) ? $cals = $_SESSION['cals'] : $cals = 'cals';





try {


$now_day = date("j");
$now_month = date("n");
$now_year = date("Y");

$all_params_id = "all_params";
$all_others_id = "all_others";

//$link = db_connect();
$db = new PulsarArchiveDB();
$db->connect( DB_SERVER . ':' . DB_PORT, DB_USERNAME, DB_PASS, DB_NAME );


//$link = db_connect_admin();
//loadNewTables();
//////////////////////////////
// Initialise error messages
//

$date_error = "";

///////////////////////////////////
// Find out the first and last dates
//$query = "select min(mjd), max(mjd) from ".OBSERVATIONS_TABLE;

$min_mjd = '';
$max_mjd = '';

$db->GetMinMaxMJD( $min_mjd, $max_mjd );

// Convert from MJD to JD
$min_jd = $min_mjd + 2400000.5;
$max_jd = $max_mjd + 2400000.5;

// convert the mjd to a date
$min_jd = floor($min_jd);
$max_jd = ceil($max_jd);

$min_unix = jdtounix($min_jd);
$max_unix = jdtounix($max_jd);
$min_date_text = date("j F Y", $min_unix);
$max_date_text = date("j F Y", $max_unix);
$minDay   = date("j",$min_unix);
$minMonth = date("n",$min_unix);
$minYear  = date("Y",$min_unix);
$maxDay   = date("j",$max_unix);
$maxMonth = date("n",$max_unix);
$maxYear  = date("Y",$max_unix);

// proprietry date limit
$today_mjd = cal_to_jd ( CAL_GREGORIAN, date("n"), date("j"), date("Y") ) - 2400000.5;
$prop_mjd = $today_mjd - PROPRIETRY_PERIOD_DAY;
$prop_unix = jdtounix($prop_mjd+2400000.5);
$prop_date_text = date("j F Y", $prop_unix);



// Clear any old form inputs in session cache
init();

//////////////////////////////////////////////
// Get the field names to fill form checkboxes

$fields = $db->GetObservationFields();

$field_names = Array("filename" => "Filename",
		     "src_name" => "Source Name",
		     "project_id" => "Project ID",
		     "raj" => "RA (J2000, hh:mm:ss)",
		     "decj" => "Dec (J2000, dd:mm:ss)",
		     "data_type" => "Data Type",
		     "obsfreq" => "Frequency",
		     "bw" => "Bandwidth",
		     "scanlen" => "Scan Length",
		     "date" => "UT Date",
		     "ut" => "UT Time",
		     "MJD" => "MJD",
		     "rajd" => "RA (J2000, degs)",
		     "decjd" => "Dec (J2000, degs)",
		     "gl" => "Gal. Long. (degs)",
		     "gb" => "Gal. Lat. (degs)",
		     "BMAJ" => "Beamsize: BMAJ",
		     "BMIN" => "Beamsize: BMIN",
		     "BPA" => "Beam: BPA",
		     "dm" => "D.M.",
		     "period" => "Period",
		     "nchan" => "# channels",
		     "npol" => "# polarisations",
		     "nbin" => "# bins",
		     "nsub" => "# subintegrations",
		     "tsamp" => "Sample time",
		     "nbits" => "# bits per sample",
		     "nbeam" => "# beams",
		     "cnfg" => "Configuration",
		     "inst" => "Instrument",
		     "rcvr" => "Receiver",
		     "hdrver" => "PSRFITS version",
		     "survey" => "Survey name",
		     "telescope" => "Telescope",
		     "site" => "Site ID",
		     "obsrvr" => "Observer ID" );

/////////////////////////////////////////////////
// Load search form parameters if they have been stored.
//



///////////////////////////////////////////////
// Get the data types available in the database
//

$data_types = $db->GetDataTypes();

///////////////////////////////////////////////
// If the user clicked on the logout button
if (isset($HTTP_GET_VARS['command'])) {
  $command = $HTTP_GET_VARS['command'];
  if ($command == 'logout') {
    //unset($_SESSION['auth_code']);
    //unset($_SESSION['username']);
    $_SESSION = array();
  }
  if ($command == 'Login') {
    echo 'we are logging in';
    exit;
  }
}


// if we have already authenticated
//   use our stored authentication details
// otherwise
//   if we have received a login attempt
//     process it

$auth_code = false;
if( isset( $_SESSION['auth_code'] ) && $_SESSION['auth_code'] == OK )
{
  $auth_code = $_SESSION['auth_code'];
  $username = $_SESSION['username'];
}
else
{
  if( isset( $HTTP_POST_VARS['action'] ) && $HTTP_POST_VARS['action'] == 'Login' )
  {
    $username = $HTTP_POST_VARS["opalEmail"];
    $password = $HTTP_POST_VARS["opalPassword"];
    $type = $HTTP_POST_VARS['authenticateType'];
    if($type == "anon"){
      $username = $HTTP_POST_VARS["email"];
      $auth_code = OK;
      logger_login( $username, 'Anonymous', 'success' );
    }
    else
    {
      $auth_code = authenticate($username, $password);
      if( $auth_code == OK )
        logger_login( $username, 'Opal', 'success' );
      else
        logger_login( $username, 'Opal', 'failure' );
      //$auth_code = newAuthenticate();
    }
  }
}

// Initial state where no username or password supplied OR bad login state
if ($auth_code != OK) {

OutputLoginForm();

} else { 
	$_SESSION['username'] = $username;
	$_SESSION['auth_code'] = $auth_code;
	$_SESSION['logintype'] = $HTTP_POST_VARS['authenticateType'];

        isset( $HTTP_GET_VARS['actions'] ) ? $actions = $HTTP_GET_VARS['actions'] : $actions = Array();
	
	if ($actions == "new_query") {
		init();
	}
	else if ($actions == "error") {
	  //		$date_error = "You are only authorised to access data > 18 months old";
	}
        
        OutputQueryFormHeader( $min_date_text, $max_date_text );
        
?>


<!--<table class="noborder">
<tr><td><a class="top_menu" href="<?php echo $PHP_SELF; ?>?command=logout">Logout</a> | <a class="top_menu" href="change_password.html?prev_page=<?php echo urlencode("index.php"); ?>">Change Password</a></td>
</tr>
</table>-->


<form action="query.php" method="GET" name="data_archive_form" id="data_archive_form">
<input type="hidden" name="state" value="results">
    

    
    
<table class="noborder" cellpadding=0>

    <tr><td colspan=3>
	<br>
	<center><input type="submit" value="submit" name="submit_button" style="float: center;"> &nbsp;
	<input type="reset" value="reset" name="reset_button" style="float: center;"></center>
	<br>
    </td></tr>
    
    <tr>
	
<!-- **************************** -->
    <td valign="top" class="form_field" rowspan="1">

    <fieldset>
		<legend>DISPLAY PARAMETERS</legend>
		<input type="checkbox" name="<?php echo $all_params_id; ?>" id="<?php echo $all_params_id; ?>" onClick="checkAll('<?php echo $all_params_id; ?>', 'data_archive_form', 'params[]')" >Select all<br>
			<!--font size="-1"><a href="javascript:togglecomments('params', 'toggler1')" id="toggler1">Show all >></a></font--><br>
			<!span class="commenthidden" id="params">
			<div id="list">
				<?php
				foreach ($fields as $field) {
                                                                                if( isset( $field_names[$field['Field']] ) )
                                                                                {
				  echo "<input
onClick=\"updateSelectAll('".$field['Field']."', '$all_params_id')\" type=\"checkbox\" name=\"params[]\" value=\"".$field['Field']."\" id=\"".$field['Field']."\"";
				  if( in_array( $field['Field'], $selected_fields ) )
				    echo ' checked="true"';
				  echo " >".$field_names[$field['Field']]."<br>\n";
                                                                                }
				}
				?>
			</div>
			</span>
	</fieldset>
			
	</td>

<!-- **************************** -->

	<td class="form_field" height="10%" rowspan="1">
	<!-- Position Options -->

	<table cellspacing=0 cellpadding=0 style="border: 0px;">
        <tr><td>
        <fieldset id="flsPosition">
 		<legend>POSITION REQUIREMENTS</legend>
               
		<!-- Pulsar Name -->
		<fieldset>
		<legend>Pulsar Name</legend>
		<input type="text" name="pulsar_name" size="20" value="<?php echo $pulsar_name;?>">
                <br>
		<p>Note that search-by-name takes precedence over search-by-RA/Dec.</p>
		</fieldset>

                <br>
		
    	        <fieldset>
		<legend>Right Ascension (J2000)</legend>
		
		<input type="text" id="txtRAHour" name="rahour" size="3" tabindex="1" value="<?php echo $rahour;?>"/>
		<label for="txtRAHour" class="coordinate"><abbr title="hours"><sup>h</sup></abbr></label>
					     
		    <input type="text" id="txtRAMinute" name="ramin" size="3" tabindex="1" value="<?php echo $ramin;?>"/>
		<label for="txtRAMinute" class="coordinate"><abbr title="minutes"><sup>m</sup></abbr></label>
		
		    <input type="text" id="txtRASecond" name="rasec" size="6" tabindex="1" value="<?php echo $rasec;?>"/>
		<label for="txtRASecond" class="coordinate"><abbr title="seconds"><sup>s</sup></abbr></label>
		</fieldset>
	
	        <fieldset>
		<legend>Declination (J2000)</legend>
		
		    <input type="text" id="txtDecDegree" name="decdeg" size="3" tabindex="1" value="<?php echo $decdeg;?>"/>
		<label for="txtDecDegree" class="coordinate"><abbr title="degrees">&deg;</abbr></label>
		
		    <input type="text" id="txtDecMinute" name="decmin" size="3" tabindex="1" value="<?php echo $decmin;?>"/>
		<label for="txtDecMinute" class="coordinate"><abbr title="minutes">&prime;</abbr></label>
		
		    <input type="text" id="txtDecSecond" name="decsec" size="6" tabindex="1" value="<?php echo $decsec;?>"/>
		<label for="txtDecSecond" class="coordinate"><abbr title="seconds">&Prime;</abbr></label>
	        </fieldset>

                <br>
                <br>
	</fieldset>

        <fieldset id="flsSearchRadius">
	<legend>SEARCH WINDOW [arcmin]</legend>
	<input type="text" id="txtSearchWindow" name="radius" size="20" tabindex="1" value="<?php echo $radius;?>"/>
        </fieldset>

<br>
        <fieldset id="flsProjectID">
	<legend>PROJECT ID</legend>
	<input type="text" id="txtSearchWindow" name="projID" size="20" tabindex="1" value="<?php echo $project_id;?>"/>
        </fieldset>

        </td></tr>
</table>
</td>

<!-- **************************** -->

	<td class="form_field" height="10%">
	<!-- Filter Options -->
	<table cellspacing=0 cellpadding=0 style="border: 0px;">
        <tr><td>
	<fieldset id="flsObsDate">
				
		<legend>FILTER OPTIONS</legend>
<br>

		<!-- Date range -->
		<fieldset>
			<legend>Date Range</legend>
			
			  From:									      
			    <select name="from_day">
			    <?php
			    for ($i = 1; $i <= 31; $i++) {
			      echo "\t\t\t<option";
			      if ($i == $from_day || $from_day == '' && $i == $minDay) { echo " selected"; }
			      echo " value=\"$i\">$i</option>\n";
			    }
				?>
			    </select> 
			<select name="from_month">
				<?php
				$monthlist = cal_info(0);
				for ($i = 1; $i <= 12; $i++) {
				  echo "\t\t\t<option";
				  $month = $monthlist['abbrevmonths'][$i];
				  if ($i == $from_month || $from_month == '' && $i == $minMonth) { echo " selected"; }
				  echo " value=\"$i\">$month</option>\n";
				}
				?>
				  </select> 
<!-- <input type="text" size="4" name="from_year" value="<?php echo $min_cal_assoc['year']; ?>"> -->
     		      <select name="from_year">
				      <?php
				      for ($i = $minYear; $i <= $maxYear; $i++) {
					echo "\t\t\t<option";
					if ($i == $from_year || $from_year == '' && $i == $minYear ) { echo " selected"; }
				  echo " value=\"$i\">$i</option>\n";
				}
				?>
			    </select> 
			<?php echo "<font size=\"-1\" color=\"red\">$date_error</font>" ?>
				&nbsp To: 
			<select name="to_day">
				<?php
					for ($i = 1; $i <= 31; $i++) {
					  echo "\t\t\t<option";
					  if ($i == $to_day || $to_day == '' && $i == $maxDay) { echo " selected"; }
					  echo " value=\"$i\">$i</option>\n";
					}
				?>
			</select> 
			<select name="to_month">
				<?php
			    for ($i = 1; $i <= 12; $i++) {
			      echo "\t\t\t<option";
			      $month = $monthlist['abbrevmonths'][$i];
			      if ($i == $to_month || $to_month == '' && $i == $maxMonth) { echo " selected"; }
			      echo " value=\"$i\">$month</option>\n";
			    }
				?>
			</select> 
     		      <select name="to_year">
				      <?php
				      for ($i = $minYear; $i <= $maxYear; $i++) {
					echo "\t\t\t<option";
					if ($i == $to_year || $to_year == '' && $i == $maxYear ) { echo " selected"; }
				  echo " value=\"$i\">$i</option>\n";
				}
				?>
			    </select> 
		</fieldset>
 
<br>
		<!-- Obs Mode -->
		<fieldset>
		  <legend>Obs Mode</legend>

		  <select name="obs_mode" onchange="ObsModeChanged()" id="ObsModeList">
		    <option value="any" <?php if($obs_mode == 'any') echo 'SELECTED';?> > Any </option>
		    <option value="timing" <?php if($obs_mode == 'timing') echo 'SELECTED';?>> Only timing data </option>
		    <option value="search" <?php if($obs_mode == 'search') echo 'SELECTED';?>> Only search data </option>
                  </select>
		</fieldset>

		<!-- Data Type -->
		<fieldset>
			<legend>Data Type</legend>

			<select name="data_type">
				<option value="" selected> Any </option>
				<?php
				foreach ($data_types as $next_type) {
					echo '<option value="' . $next_type['data_type'] . '"';
					if( $next_type['data_type'] == $data_type ) echo ' SELECTED ';
					echo '> ' . $next_type['data_type'] . '</option>';
				}
				?>
			</select> 
		</fieldset>	

		<!-- Frequency band -->
                <fieldset>
			<legend>Band Name</legend> 
			    <select id="selBand" name="bandname[]" multiple="multiple" size="5">
			    <option value="anyBand" 
				    <?php if( in_array( 'anyBand', $bandname ) ) echo 'SELECTED';?> 
				    >Any
			    </option>
			    <option value="70cm"   
				<?php if( in_array( '70cm', $bandname ) ) echo 'SELECTED';?>
				>70cm (~0.44 GHz)
		            </option>
			    <option value="50cm"
				    <?php if( in_array( '50cm', $bandname ) ) echo 'SELECTED';?>
				    >50cm (~0.66 GHz)
			    </option>
			    <option value="20cm"
			            <?php if( in_array( '20cm', $bandname ) ) echo 'SELECTED';?>
				    >20/18cm (1.2-1.8 GHz)
			    </option>
			    <option value="13cm"
				    <?php if( in_array( '13cm', $bandname ) ) echo 'SELECTED';?>
				    >13cm (2.0-2.5 GHz)
			    </option>
			    <option value="10cm"
				    <?php if( in_array( '10cm', $bandname ) ) echo 'SELECTED';?>
				    >10cm (2.6-3.6 GHz)
			    </option>
			    <option value="6cm"
				    <?php if( in_array( '6cm', $bandname ) ) echo 'SELECTED';?>
				    >6cm (4.5-5.1 GHz)
			    </option>
			    <option value="5cm"
				    <?php if( in_array( '5cm', $bandname ) ) echo 'SELECTED';?>
				    >5cm (5.9-6.8 GHz)
			    </option>
			    <option value="3cm"
				    <?php if( in_array( '3cm', $bandname ) ) echo 'SELECTED';?>
				    >3cm (8.1-8.6 GHz)
			    </option>
			    <option value="1.3cm"
				    <?php if( in_array( '1.3cm', $bandname ) ) echo 'SELECTED';?>
				    >1.3cm (21.-24. GHz)
			    </option>
	  </select>
     </fieldset>

       </fieldset>
        </td></tr>
        <tr><td>
	        <fieldset>
		    <legend>ORDER RESULTS BY</legend>
			    <table cellspacing="0px" cellpadding="0px" style="border: 0px;">
			    <tr><td>
		      <select name="orderBy" id="OrderByList">
			    <option value="distance" <?php if($orderBy == 'distance') echo 'SELECTED';?>>Distance
		            <option value="date" <?php if($orderBy == 'date') echo 'SELECTED';?>>Date
			    <option value="obsfreq" <?php if($orderBy == 'obsfreq') echo 'SELECTED';?>>Frequency
			    <option value="filename" <?php if($orderBy == 'filename') echo 'SELECTED';?>>Filename
		      </select>
			    </td><td>
			    &nbsp;<input type="radio" name="orderDir" id="orderDirectionSel" value="asc"
			         <?php if( $orderDir == 'asc' ) echo 'checked';?>
			         >Ascending
			    <br>
			    &nbsp;<input type="radio" name="orderDir" id="orderDirectionSel" value="desc"
				 <?php if( $orderDir == 'desc' ) echo 'checked';?>
				 >Descending
			    </td></tr>
			    </table>
		    <br>
	        </fieldset>
	</td></tr>
        <tr><td>
	        <fieldset>
		    <legend>DISPLAY OTHER DATA</legend>
				
		    <input type="checkbox" name="cals" value="cals" id="cals"
				<?php if( $cals == 'cals' ) echo 'checked'; ?>
				/>
				Display Cals taken within 
		    <input type="text" name="cals_within_mins" maxlength="5" size="3"
				<?php if( $cals_within_mins != '' ) echo 'value="' . $cals_within_mins . '"';?>
				/>
				mins of Observations
		    <br>
	        </fieldset>
	</td></tr>
        </table>
	<br>
	</td>
	</tr>	
</table>


</form>
<div style="min-height: 20px; max-height: 1000px;"> </div>
<?php 
}

} catch( MysqlDBException $e ) {
  logger_exception( $_SESSION['username'], $e->getCode(), $e->getMessage(), '' );
  echo '<p><div class="exception_box">' .
       '<center>' .
       '<b>A database error was encountered</b> <br>' .
       'the details of the error have been logged, please contact the system administrator for futher assistance <br>' .
       '</center>' .
       '</div><p>';
}

?>
</div>

<div id=\"footer\">
<?php   include "footer.html"; ?>
</div>

</body>

</html>


<?php //////////// Function definitions ///////////////


// Initialise the input form variables. If the "New query" button is clicked
// no argument is passed to init(), hence the need for a default NULL value
// because there is no need for updating user access statistics
function init($link=NULL) {

	unset($_SESSION['cals']); // The result set of cals
	unset($_SESSION['obs']); // The result set of observations
	//unset($_SESSION['cart_items']); // The result set of observations
}




?>
