<?php	


  // logger.php
  // This is the logging script for the data archiving system
  //
  // Written by: Albert Teoh
  // Date: 2.2.2006

  require_once 'constants.php';


  function logger_write( $username, $action, $param1, $param2, $param3 ) 
  {

    // Get the filename
    $date = date("n Y");

    list($month, $year) = split(' ', $date);

    $filename = LOG_DIR . "/$year$month.log";

    $string = "\"" . date('d-m-y') . "\"\t\"" .
	date( 'h:i:s') . "\"\t\"" .
	$username . "\"\t\"" .
	$action . "\"\t\"" .
	$param1 . "\"\t\"" .
	$param2 . "\"\t\"" .
	$param3 . "\"\n";

    if (!file_exists($filename)) {
      touch($filename);
    }

    if (is_writable($filename)) {
      if (!$handle = fopen($filename, "a+")) {
	      //echo "Cannot open log file ($filename)<br>\n";
      }
      else {

	if (fwrite($handle, $string) === FALSE) {
		//echo "Cannot write to log file $file<br>\n";
	}

	fclose($handle);
      }
    }
    else {
      //echo "Cannot write to log file ($filename)<br>\n";
    }
  }
  
  function logger_download( $username, $dir, $filename, $size )
  {
    logger_write( $username, 'download', $dir, $filename, $size );
  }
  
  function logger_query( $username, $query, $num_results )
  {
    logger_write( $username, 'query', $query, $num_results, '' );
  }
  
  function logger_login( $username, $method, $success )
  {
    logger_write( $username, 'login', $method, $success, '' );
  }
  function logger_exception( $username, $type, $description )
  {
    logger_write( $username, 'Exception', $type, $description, '' );
  }
?>
