<?php

// A set of commonly used functions
// Albert Teoh
// 27.3.2006

include_once 'constants.php';
include_once 'MysqlDB.php';
require_once 'Classes/General/File.php';
require_once 'ArchiveScruncher.php';
require_once 'TarBuilder.php';

///////////////////////////////////////////////////////

// Initialise the input form variables
function init() {
  global $actions, $selected_obs;
	
  unset($actions);
  unset($selected_obs);

  unset($_SESSION['selected_obs']);
  unset($_SESSION['actions']);
}

///////////////////////////////////////////////////////

// Gets the parameter from the HTTP_GET_VARS or HTTP_POST_VARS assoc 
// array first. If not set, then gets it off the session
// variable
function get_param($param_name, $http_vars) {
	
		
  $param = "";
	
  if (isset($http_vars[$param_name])) {
    $param = $http_vars[$param_name];
		
    // Set the session variable
    $_SESSION[$param_name] = $param;
		
  }
  else if(isset( $_SESSION['$param_name'] ) )
  {
    $param = $_SESSION[$param_name];
  }
	
  return $param;
}



/**
 * 
 **/
function tarFiles( $cart_obs, $all_results, $db, $add_obs, $add_cals )
{
  // create a tar file manager
  // for each file
  //   if the file needs to be scrunched
  //     scrunch the archive
  //   otherwise
  //     link the archive
  //   add the file to the tar file manager
  //   get a list of any cals within the timeframe
  //   for each cal
  //     link to the cal file
  //     add the file to the tar file manager
  // create the tar file
  // create a url to the tar file
  // output the link and a message
  // output a redirect to the tar file

  $tar_filename = date('YmdHis') . '.tar';
      
  $tar_file = new File( WORKING_DIR . '/', $tar_filename );
      
  $tar_builder = new TarBuilder();
  $tar_builder->SetSrcDir( WORKING_DIR . '/' );
  $tar_builder->SetTarFile( $tar_file );
  
  $all_files = Array();
  foreach( $cart_obs as $item )
  {
    if( $add_obs )
    {
      if( $item['pscrunch'] == 'pscrunch' ||
	  $item['tscrunch'] != '' ||
	  $item['fscrunch'] != '' )
      {
	$scruncher = new ArchiveScruncher();
	
	$src_file = new File( $item['data_loc'], $item['filename'] );
	$dest_file = new File( WORKING_DIR, $item['filename_out'] );

	if( $src_file->IsDirectory() )
	{
	  $src_dir = $src_file;
	  $dest_dir = $dest_file;
	  // create a directory in the target directory
	  // get a list of all the files in the src directory
	  // for each file
	  //   create a scruncher
	  //   scrunch it to the target directory

// TODO uncomment this test when your finished implementing
// 	  if( !$dest_dir->Exists() )
// 	  {
	    mkdir( $dest_dir->GetFullPath() );
	    if( !$dest_dir->Exists() )
	      echo 'failed to create target directory <br> ';
	    // TODO throw an exception here when we fail to create the directory
	    
            $dirhandler = opendir( $src_dir->GetFullPath() );
	    if( $dirhandler === false )
	      echo 'failed to create directory handler for source directory <br>';
	    // TODO throw an exception here
            
	    while( ($filehandler = readdir( $dirhandler )) !== false ) 
	    {
	      
	    }
// 	  }
	}
	else
	{
	  $scruncher->SetSrcFile( $src_file );
	  $scruncher->SetDestFile( $dest_file );

	  if( $item['pscrunch'] == 'pscrunch' )
	    $scruncher->PScrunch();
	  $scruncher->FScrunch( $item['fscrunch'] );
	  $scruncher->TScrunch( $item['tscrunch'] );

	  $scruncher->Execute();
	}
      }
      else
      {
	$file = $item['filename'];
	$dir = $item['data_loc'];
	if (!file_exists(WORKING_DIR."/$file")) {
	  if (file_exists("$dir/$file")) {
	    symlink ("$dir/$file", WORKING_DIR."/$file");
	  } else {
	    // TODO throw an exception if the target file doesn't exist
		echo 'failed to create link for non scrunched file <br> ';
	  }
	}
      }
      $tar_builder->AddFile( $item['filename_out'] );
    }
    
    if( $add_cals )
    {
      $path = $item['data_loc'] . '/' . $item['filename'];
      $all_cals = query_cals($path, $item['cals_within_mins'],$db);
      foreach ($all_cals as $cal) 
      {
	$cal_file = $cal['filename'];
	$cal_dir = $cal['data_loc'];
  
	if (!file_exists(WORKING_DIR."/$cal_file")) {
	  if (file_exists("$cal_dir/$cal_file")) {
	    symlink ("$cal_dir/$cal_file", WORKING_DIR."/$cal_file");
	  }
	}
	$tar_builder->AddFile( $cal_file );
      }
    }
  }

  $tar_builder->Execute();

  if (file_exists(WORKING_DIR."/$tar_filename")) {
    echo "Your requested archive set was successfully packaged. If you haven't been redirected to the tar
	file, you may access it directly by clicking on the following link:<br>
	<a href=\"".DATA_ARCHIVE_URL."/downloads/$tar_filename\">".DATA_ARCHIVE_URL."/downloads/$tar_filename</a><br>\n";
		
    return "$tar_filename";
  }
  else
    echo 'the tar file wasn\'t created properly <br>';
}


function hms2degs($hms_str) {

  list($hour, $min, $sec) = split(":", $hms_str);
	
  return ($hour + $min/60 + $sec/60)*HOURS2DEGS;
}

function dms2degs($dms_str) {
	
  list($deg, $min, $sec) = split(":", $dms_str) ;
	
  return $deg + $min/60 + $sec/60;
}


// Query the cals table for respective cals
//function query_cals($pulsar_name, $mjd, $data_type, $span_mins) {
function query_cals($pathname, $span_mins, $db) {

  // Query the obs table to get the data file we are finding cals for.
  // Only need to look in the obs table as there are no cals for the s70 data.
  //  Use the full pathname of the file to make sure we get the correct entry.

  $obsquery = "SELECT src_name,MJD,data_type FROM ".OBSERVATIONS_TABLE." WHERE concat(data_loc,'/',filename)='$pathname'";

  $db->DoQuery( $obsquery );

  $all_cals = Array();

  if( $db->FetchNumRows() > 0 )
  {
    $row = $db->FetchRowAsArray();

    $src = $row['src_name'];
    $mjd = $row['MJD'];
    $type= $row['data_type'];

    $mjd_max = mjd_add($mjd, $span_mins);
    $mjd_min = mjd_add($mjd, $span_mins*-1);

    $query = "SELECT * FROM ".CALS_TABLE." WHERE (MJD > $mjd_min) AND (MJD < $mjd_max) AND src_name LIKE '$src%' AND data_type = '$type' order by MJD";

    $db->DoQuery( $query );
    $all_cals = $db->GetLastResult();
  }

  return $all_cals;
}


function array2urlstring($arrayName, $array ) {
  $str = "";
  $brackets = urlencode("[]");
	
  if(is_array($array)){
    foreach ($array as $item) {
      $str .= "$arrayName$brackets=$item&";
    }
  }
  $str = trim($str, "&");
  return $str;
}



/**
 * array_diff2  Subtract rhs from lhs, both are arrays of arrays. This is used when you have an array of 
 *              records, each represented by an array, and you have a copy of one of those records that
 *              you wish to remove.
 *
 * @param lhs   The array to subtract from
 * @param rhs   The array to subtract
 * @example e   array_diff2( Array( Array( 'help' ), Array('me') ), Array( Array( 'help' ) ) )
 *              will return Array( Array( 'me' ) );
 **/
 
function array_diff2( $lhs, $rhs )
{
  $result = Array();
  foreach( $lhs as $next )
    if( !in_array( $next, $rhs ) )
      $result[] = $next;
  return $result;
}

?>
